/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.media.AMedia;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Filedownload;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.DispositivoEmbarcada;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.enums.SistemaEnum;
import com.rjconsultores.ventaboletos.relatorios.impl.RelatorioPdfAndExcel;
import com.rjconsultores.ventaboletos.service.DispositivoEmbarcadaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxEstandar;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxPuntoVenta;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderDispositivoVendaEmbarcada;
import com.trg.search.Search;

/**
 *
 * @author Fabricio
 */
@Controller("busquedaDispositivoVendaEmbarcadaController")
@Scope("prototype")
public class BusquedaDispositivoVendaEmbarcadaController extends MyGenericForwardComposer {

	private static final String NOME_RELATORIO = "relatorioDispositivoEmbarcada";
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<DispositivoEmbarcada> plwDispositivoVendaEmbarcada;
	private MyComboboxEstandar cmbEmpresa;
	private List<Empresa> lsEmpresa;
	private List<SistemaEnum> lsSistemaEnum;
	private MyComboboxPuntoVenta cmbPuntoVenta;
	private Textbox txtDescricao;
	private Textbox txtRegistro;
	private MyComboboxEstandar cmbVersaoUltimaSinc;
	private Textbox txtMei;
	private MyListbox dispositivoVendaEmbarcadaList;
	private Search dispositivoVendaEmbarcadaBusqueda;
	private Checkbox chkDispBloqueadoSim;
	private Checkbox chkDispBloqueadoNao;
	private Checkbox chkDispManutencaoSim;
	private Checkbox chkDispManutencaoNao;
	private Checkbox chkDispBaixadoSim;
	private Checkbox chkDispBaixadoNao;
	private boolean isNovoDispositivo;
	private List<String> lsVersoesDispoitivos;
	@Autowired
	private DispositivoEmbarcadaService dispositivoEmbarcadaService;



	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);
		this.lsEmpresa = UsuarioLogado.getUsuarioLogado().getEmpresa();
		setLsVersoesDispoitivos(dispositivoEmbarcadaService.buscarAllVersaoUltimaSinc());
		lsSistemaEnum = Arrays.asList(SistemaEnum.values());

		dispositivoVendaEmbarcadaList.setItemRenderer(new RenderDispositivoVendaEmbarcada());
		dispositivoVendaEmbarcadaList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				DispositivoEmbarcada a = (DispositivoEmbarcada) dispositivoVendaEmbarcadaList.getSelected();
				verDispositivoVendaEmbarcada(a);
			}
		});

		refreshLista();

		cmbEmpresa.focus();
	}

	private void verDispositivoVendaEmbarcada(DispositivoEmbarcada a) {
		if (a == null) {
			return;
		}

		Map<String, Object> args = new HashMap<String, Object>();
		args.put("dispositivoVendaEmbarcada", a);
		args.put("dispositivoVendaEmbarcadaList", dispositivoVendaEmbarcadaList);
		args.put("isNovoDispositivo", isNovoDispositivo);

		openWindow("/gui/catalogos/editarDispositivoVendaEmbarcada.zul",
				Labels.getLabel("dispositivoVendaEmbarcadaController.window.title"), args, MODAL);
	}

	private void refreshLista() {
		HibernateSearchObject<DispositivoEmbarcada> dispositivoEmbarcadaBusqueda = new HibernateSearchObject<DispositivoEmbarcada>(DispositivoEmbarcada.class);

		dispositivoEmbarcadaBusqueda.addFilterLike("descricao",
				"%" + txtDescricao.getText().trim().concat("%"));
		
		dispositivoEmbarcadaBusqueda.addFilterLike("registro",
				"%" + txtRegistro.getText().trim().concat("%"));
		
		if (cmbVersaoUltimaSinc.getSelectedItem() !=null && cmbVersaoUltimaSinc.getSelectedItem().getValue() != null
				&& !cmbVersaoUltimaSinc.getSelectedItem().getValue().toString().isEmpty()) {
			dispositivoEmbarcadaBusqueda.addFilterEqual("versaoUltimaSinc", cmbVersaoUltimaSinc.getSelectedItem().getValue().toString());
		}
		
		dispositivoEmbarcadaBusqueda.addFilterLike("imei",
				"%" + txtMei.getText().trim().concat("%"));
		
		if (chkDispBloqueadoSim.isChecked()) {
			dispositivoEmbarcadaBusqueda.addFilterEqual("indDispBloqueado", true);
		}
		if (chkDispBloqueadoNao.isChecked()) {
			dispositivoEmbarcadaBusqueda.addFilterEqual("indDispBloqueado", false);
		}
		if (chkDispManutencaoSim.isChecked()) {
			dispositivoEmbarcadaBusqueda.addFilterEqual("indDispManutencao", true);
		}
		if (chkDispManutencaoNao.isChecked()) {
			dispositivoEmbarcadaBusqueda.addFilterEqual("indDispManutencao", false);
		}
		if (chkDispBaixadoSim.isChecked()) {
			dispositivoEmbarcadaBusqueda.addFilterEqual("indDispBaixado", true);
		}
		if (chkDispBaixadoNao.isChecked()) {
			dispositivoEmbarcadaBusqueda.addFilterEqual("indDispBaixado", false);
		}
		
		Comboitem cbiEmpresa = cmbEmpresa.getSelectedItem();
        if (cbiEmpresa != null) {
        	Empresa dab = (Empresa) cbiEmpresa.getValue();
            dispositivoEmbarcadaBusqueda.addFilterEqual("empresa.empresaId", dab.getEmpresaId());
        }
        
        Comboitem cbiPuntoVenta = cmbPuntoVenta.getSelectedItem();
        if (cbiPuntoVenta != null) {
        	PuntoVenta dab = (PuntoVenta) cbiPuntoVenta.getValue();
            dispositivoEmbarcadaBusqueda.addFilterEqual("puntoVenta.puntoventaId", dab.getPuntoventaId());
        }

        dispositivoVendaEmbarcadaList.setData(plwDispositivoVendaEmbarcada.searchObject(dispositivoEmbarcadaBusqueda));

		if (dispositivoVendaEmbarcadaList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("dispositivoVendaEmbarcadaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public void onClick$btnPesquisa(Event ev) {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}
	
	public void onClick$btnExportarPdf(Event ev) throws SQLException, Exception {
		excutarRelatorios(true);
	}
	
	public void onClick$btnExportarXls(Event ev) throws SQLException, Exception {
		excutarRelatorios(false);
	}

	public void onClick$btnNovo(Event ev) {
		isNovoDispositivo = true;
		verDispositivoVendaEmbarcada(new DispositivoEmbarcada());
	}
	
	public void excutarRelatorios(boolean isPdf) throws SQLException, Exception {

		RelatorioPdfAndExcel r = new RelatorioPdfAndExcel(dispositivoVendaEmbarcadaList);
		InputStream mediais = new ByteArrayInputStream(r.generateReportRender(isPdf));
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd_HH-mm");
		String nomeRelatorioDownload = NOME_RELATORIO + "_" + sdf.format(Calendar.getInstance().getTime());

		if(isPdf) {
			AMedia conteudoRelatorioXLS = new AMedia("relatorio.pdf", "pdf", null, mediais);
			Filedownload.save(conteudoRelatorioXLS.getStreamData(), "application/pdf", nomeRelatorioDownload + ".pdf");
		}else {
			AMedia conteudoRelatorioXLS = new AMedia("relatorio.xls", "xls", null, mediais);
			Filedownload.save(conteudoRelatorioXLS.getStreamData(), "application/xls", nomeRelatorioDownload + ".xls");
		}
		
	}

	public List<SistemaEnum> getLsSistemaEnum() {
		return lsSistemaEnum;
	}

	public void setLsSistemaEnum(List<SistemaEnum> lsSistemaEnum) {
		this.lsSistemaEnum = lsSistemaEnum;
	}

	public PagedListWrapper<DispositivoEmbarcada> getPlwplwDispositivoVendaEmbarcada() {
		return plwDispositivoVendaEmbarcada;
	}

	public void setPlwDispositivoVendaEmbarcada(PagedListWrapper<DispositivoEmbarcada> plwDispositivoVendaEmbarcada) {
		this.plwDispositivoVendaEmbarcada = plwDispositivoVendaEmbarcada;
	}

	public Combobox getCmbEmpresa() {
		return cmbEmpresa;
	}

	public void setCmbEmpresa(MyComboboxEstandar cmbEmpresa) {
		this.cmbEmpresa = cmbEmpresa;
	}

	public List<Empresa> getLsEmpresa() {
		return lsEmpresa;
	}

	public void setLsEmpresa(List<Empresa> lsEmpresa) {
		this.lsEmpresa = lsEmpresa;
	}

	public Textbox getTxtDescricao() {
		return txtDescricao;
	}

	public void setTxtDescricao(Textbox txtDescricao) {
		this.txtDescricao = txtDescricao;
	}

	public Textbox getTxtRegistro() {
		return txtRegistro;
	}

	public void setTxtRegistro(Textbox txtRegistro) {
		this.txtRegistro = txtRegistro;
	}


	public Textbox getTxtMei() {
		return txtMei;
	}

	public void setTxtMei(Textbox txtMei) {
		this.txtMei = txtMei;
	}

	public MyListbox getDispositivoVendaEmbarcadaList() {
		return dispositivoVendaEmbarcadaList;
	}

	public void setDispositivoVendaEmbarcadaList(MyListbox dispositivoVendaEmbarcadaList) {
		this.dispositivoVendaEmbarcadaList = dispositivoVendaEmbarcadaList;
	}

	public Search getDispositivoVendaEmbarcadaBusqueda() {
		return dispositivoVendaEmbarcadaBusqueda;
	}

	public void setDispositivoVendaEmbarcadaBusqueda(Search dispositivoVendaEmbarcadaBusqueda) {
		this.dispositivoVendaEmbarcadaBusqueda = dispositivoVendaEmbarcadaBusqueda;
	}

	public PagedListWrapper<DispositivoEmbarcada> getPlwDispositivoVendaEmbarcada() {
		return plwDispositivoVendaEmbarcada;
	}

	public Checkbox getChkDispBloqueadoSim() {
		return chkDispBloqueadoSim;
	}

	public void setChkDispBloqueadoSim(Checkbox chkDispBloqueadoSim) {
		this.chkDispBloqueadoSim = chkDispBloqueadoSim;
	}

	public Checkbox getChkDispBloqueadoNao() {
		return chkDispBloqueadoNao;
	}

	public void setChkDispBloqueadoNao(Checkbox chkDispBloqueadoNao) {
		this.chkDispBloqueadoNao = chkDispBloqueadoNao;
	}

	public Checkbox getChkDispManutencaoSim() {
		return chkDispManutencaoSim;
	}

	public void setChkDispManutencaoSim(Checkbox chkDispManutencaoSim) {
		this.chkDispManutencaoSim = chkDispManutencaoSim;
	}

	public Checkbox getChkDispManutencaoNao() {
		return chkDispManutencaoNao;
	}

	public void setChkDispManutencaoNao(Checkbox chkDispManutencaoNao) {
		this.chkDispManutencaoNao = chkDispManutencaoNao;
	}

	public Checkbox getChkDispBaixadoSim() {
		return chkDispBaixadoSim;
	}

	public void setChkDispBaixadoSim(Checkbox chkDispBaixadoSim) {
		this.chkDispBaixadoSim = chkDispBaixadoSim;
	}

	public Checkbox getChkDispBaixadoNao() {
		return chkDispBaixadoNao;
	}

	public void setChkDispBaixadoNao(Checkbox chkDispBaixadoNao) {
		this.chkDispBaixadoNao = chkDispBaixadoNao;
	}
	
	public MyComboboxEstandar getCmbVersaoUltimaSinc() {
		return cmbVersaoUltimaSinc;
	}

	public void setCmbVersaoUltimaSinc(MyComboboxEstandar cmbVersaoUltimaSinc) {
		this.cmbVersaoUltimaSinc = cmbVersaoUltimaSinc;
	}

	public List<String> getLsVersoesDispoitivos() {
		return lsVersoesDispoitivos;
	}

	public void setLsVersoesDispoitivos(List<String> lsVersoesDispoitivos) {
		this.lsVersoesDispoitivos = lsVersoesDispoitivos;
	}


}
